<?php
/*
Plugin Name: Viewcount
Plugin URI: http://kometbomb.net/2008/02/18/a-simple-statistics-plugin-for-wordpress/
Description: A simple site statistics script with even more simple bar graph output.
Version: 1.1.2
Author: kometbomb
Author URI: http://kometbomb.net/
*/

function vc_update_counter($id) {
	global $wpdb;
	$table_name = $wpdb->prefix . "view_count";
	$wpdb->query("insert into $table_name (page,day) values ('".$wpdb->escape($id)."',curdate()) on duplicate key update views=views+1");

}

function update_view_count($content) {
	if ((is_single()||is_page()) && !is_user_logged_in()) {
		global $wp_query;
		$thePostID = $wp_query->post->ID;
		
		vc_update_counter($thePostID);
	}
	
	return $content;
}


function jal_install () {
	global $wpdb;

  $table_name = $wpdb->prefix . "view_count";
   
  if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
	  $sql = "CREATE TABLE " . $table_name . " (
			page int(10) NOT NULL,
			day date not NULL,
			views int(10) default 1,
			UNIQUE KEY id (page,day)
		);";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
	}
	
	
}

function get_popularity($page=-1,$days=30,$format='percent') {
	global $wpdb,$post;

	$table_name = $wpdb->prefix . "view_count";
	
	if ($page==-1) $id=$post->ID; else $id=$wpdb->escape($page);
	
	$query="select 1000*sum(views)/(select sum(views) from $table_name where datediff(curdate(), $table_name.day) between 1 and ".$wpdb->escape($days).") from $table_name where page='$id' ".
		"and datediff(curdate(), $table_name.day) between 1 and ".$wpdb->escape($days);
	
	$popularity=$wpdb->get_var($query);
	
	
	switch ($format) {
		default:
		case 'percent':
		
		return round($popularity/10.0).'%';
		
		break;
		
		case 'float':
		
		return $popularity/1000.0;
		
		break;
	}
}

function get_view_count_array($page=-1,$days=30) {
	
	global $wpdb;

  $table_name = $wpdb->prefix . "view_count";
  
 	$result=$wpdb->get_results("select ifnull(sum(views),0) as views from $table_name where datediff(curdate(), $table_name.day) between 1 and ".$wpdb->escape($days)." ".
 		($page!=-1?"and $table_name.page='".$wpdb->escape($page)."' ":"")."group by $table_name.day order by $table_name.day asc limit ".$wpdb->escape($days),ARRAY_N);
  
 	return $result;
}

function hex2dec($in) {
	$colr = str_replace('#', '', $in);
	$ret = array(
		'r' => hexdec(substr($colr, 0, 2)),
		'g' => hexdec(substr($colr, 2, 2)),
		'b' => hexdec(substr($colr, 4, 2))
	);
	return $ret;
}

function hex2color($img,$in) {
	$hex=hex2dec($in);
	return imageColorAllocate($img,$hex['r'],$hex['g'],$hex['b']);
}

function get_view_histogram($page=-1,$days=60,$barwidth=10,$barheight=16,$barspacing=1,$barcolor='#000000',$backgroundcolor='#ffffff',$web20=16) {
	
	$filename=md5('stats-'.($page!=-1?$page:'all')."$days-$barwidth-$barheight-$barspacing-$barcolor-$backgroundcolor-$web20").'.png';
	
	$fn=get_option("physical_graph_cache_location").'/'.$filename;
	
	if (!file_exists($fn)||(round(date('Ymd'))>round(date('Ymd',filemtime($fn))))) {
	
		$img=imageCreateTrueColor(($barwidth+$barspacing)*$days,$barheight+$web20);
		$background=hex2color($img,$backgroundcolor);
		
		imageFilledRectangle($img,0,0,($barwidth+$barspacing)*$days,$barheight+$web20,$background );
		
		$arr=get_view_count_array($page,$days);
		
		if ($arr) {
			$views=array();
			foreach ($arr as $day) {
				$views[]=	$day[0];
			}
			
			$bar=hex2color($img,$barcolor);
			
			$barhex=hex2dec($barcolor);
			$bghex=hex2dec($backgroundcolor);
			
			for ($r=0;$r<$web20;$r++) {
				$cr=($bghex['r']*3+($barhex['r']-($barhex['r']-$bghex['r'])*$r/$web20))/4;
				$cg=($bghex['g']*3+($barhex['g']-($barhex['g']-$bghex['g'])*$r/$web20))/4;
				$cb=($bghex['b']*3+($barhex['b']-($barhex['b']-$bghex['b'])*$r/$web20))/4;
				$reflection[$r]=imageColorAllocate($img,$cr,$cg,$cb);
			}
			
			$min=min($views);
			$max=max($views)-$min;
			
			if ($max>0) {
			
				$x=($barwidth+$barspacing)*$days-count($views)*($barwidth+$barspacing);
				foreach ($views as $day) {
					
					$h=$barheight-($day-$min)*$barheight/$max;
					imageFilledRectangle($img,$x,$barheight,$x+$barwidth-1,$h,$bar);
					for ($y=0;$y<$web20 && $y<$barheight-$h;$y++) {
						imageFilledRectangle($img,$x,$barheight+$y+1,$x+$barwidth-1,$barheight+$y+1,$reflection[$y]);
					}
					$x+=$barwidth+$barspacing;	
				}
			}
		}	
		
		imagepng($img,$fn);
		imageDestroy($img);
	}
	
	return get_option("graph_cache_location").'/'.$filename;
}

function get_view_count_list($limit=10,$days=30,$before='<li>',$after='</li>',$excludeid='',$type='') {
	global $wpdb;

  $table_name = $wpdb->prefix . "view_count";
  
 	$result=$wpdb->get_results("select ".$wpdb->posts.".ID,post_title,sum(views) as views from $table_name ".
 		"join ".$wpdb->posts." on ".$wpdb->posts.".ID=$table_name.page ".
 		"where datediff(curdate(), $table_name.day) between 1 and ".$wpdb->escape($days)." ".
 		($excludeid!=''?'and '.$wpdb->posts.'.ID not in ('.$excludeid.') ':"").
 		($type!=''?'and '.$wpdb->posts.'.post_type=\''.$wpdb->escape($type).'\' ':"").
 		"group by $table_name.page order by views desc limit ".$wpdb->escape($limit));
  
  foreach ($result as $row) {
	 	echo $before.'<a href="'.get_permalink($row->ID).'">'.$row->post_title.'</a>'.$after; 
  }
}

function get_comment_count_list($limit=10,$before='<li>',$after='</li>') {
	global $wpdb;

 	$result=$wpdb->get_results("select ".$wpdb->posts.".ID,post_title,comment_count from $wpdb->posts where comment_count>0 order by comment_count desc limit ".$wpdb->escape($limit));
  
  foreach ($result as $row) {
	 	echo $before.'<a href="'.get_permalink($row->ID).'">'.$row->post_title.'</a>'.$after; 
  }
}


function get_top_pages($days=30,$limit=10,$type='views') {
	$html='<ol class="top_list">';
	
	global $wpdb;
	 $table_name = $wpdb->prefix . "view_count";

 	$result=$wpdb->get_results("select $wpdb->posts.ID,post_title,sum(views) as views from $wpdb->posts join $table_name on $table_name.page=$wpdb->posts.ID where abs(datediff($table_name.day,curdate())) between 1 and ".$wpdb->escape($days).
		" group by $wpdb->posts.ID order by views desc limit ".$wpdb->escape($limit));
	$total=$wpdb->get_var("select sum(views) as views from  $table_name where datediff(curdate(), $table_name.day) between 1 and ".$wpdb->escape($days));
	
	foreach ($result as $row) {
		if ($type=='views') 
			$views=$row->views;
		else if ($type=='popularity')
			$views=round($row->views*100/$total).'%';
		$html.="<li><a class=\"title\" href=\"".get_permalink($row->ID)."\">".$row->post_title."</a> &mdash; <span class=\"views\">".$views." view".(($views>1)?"s":"")."</span></li>\n";
	}
	
	$html.='</ol>';
	
	return $html;
}


add_action('admin_menu', 'viewcount_add_pages');

function viewcount_add_pages() {
    // Add a new submenu under Options:
    add_options_page('Viewcount', 'Viewcount', 8, __FILE__, 'viewcount_options_page');
}

function viewcount_options_page() {
	// variables for the field and option names 
    $hidden_field_name = 'mt_submit_hidden';
   

    // Read in existing option value from database
    $physical_graph_cache_location = get_option( "physical_graph_cache_location" );
    $graph_cache_location = get_option( "graph_cache_location" );

    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( $_POST[ $hidden_field_name ] == 'Y' ) {
        // Read their posted value
        $opt_val = $_POST[ 'graph_cache_location' ];

        // Save the posted value in the database
        update_option( 'graph_cache_location', $opt_val );
        
         $opt_val = $_POST[ 'physical_graph_cache_location' ];
        update_option( 'physical_graph_cache_location', $opt_val );
        
        if (!file_exists(get_option('physical_graph_cache_location'))) {
        	@mkdir(get_option('physical_graph_cache_location'));
        	@chmod(get_option('physical_graph_cache_location'),0766);
      	}

        // Put an options updated message on the screen

?>
<div class="updated"><p><strong><?php _e('Options saved.', 'mt_trans_domain' ); ?></strong></p></div>
<?php

    }

    // Now display the options editing screen

    echo '<div class="wrap">';

    // header

    echo "<h2>" . __( 'Viewcount Options', 'mt_trans_domain' ) . "</h2>";

    // options form
    
    ?>

<form name="form1" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">

<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Update Options', 'mt_trans_domain' ) ?>" />
</p>
<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">

<p><?php _e("Graph cache location (e.g. http://example.com/graph_cache)", 'mt_trans_domain' ); ?><br/>
<input type="text" name="graph_cache_location" value="<?php echo $graph_cache_location; ?>" size="40"></p>

<p><?php _e("Physical graph cache location (e.g. /home/yourname/public_html/graph_cache)", 'mt_trans_domain' ); ?><br/>
<input type="text" name="physical_graph_cache_location" value="<?php echo $physical_graph_cache_location; ?>" size="40">
</p>


<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Update Options', 'mt_trans_domain' ) ?>" />
</p>

</form>
</div>

<?php
 

}


add_option("graph_cache_location", get_bloginfo('url').'/graph_cache', "Graph cache location (e.g. http://example.com/graph_cache)", "no");
add_option("physical_graph_cache_location", ABSPATH.'/graph_cache', "Physical graph cache location (e.g. /home/yourname/public_html/graph_cache)", "no");

add_action ( 'the_content', 'update_view_count');
register_activation_hook(__FILE__,'jal_install');

?>
